function [dat,dat2,wts]=neur(wts,nii,param)
%wts is input weights, n by 3 matrix; nii is number of iterations
%(multiplied by 30000 iterations per plot here); param is a pair, first
%parameter is training rate; second parameter is how much to regularize (0
%or 1 are good defaults)
nw=size(wts,1);
inps=[[-5.5:5.5]'/4+.07,ones(12,1)]; targ=.345+[-2 1.5 0 0 2 1 0 -1 0 1 2 -1]; np=length(targ);
if nargin==1, myplot(wts,inps); return; end
dat=zeros(401,nii); dat2=zeros(nw,3,nii);
scale=param(1); rscale=ones(size(targ))*param(2);
for ii=1:nii
    ni=30000;
    dat3=zeros(np,ni); dat4=zeros(np,ni); dat5=zeros(nw,3,ni);
    for i=1:ni,
        targdel=randn(np,1)*1.*rscale';
        [dat3(:,i),upd]=netw(wts+randn(size(wts))*0e-1,inps,targ'+targdel); wts=wts+scale*upd*diag([1 1 1]); dat4(:,i)=targ'+targdel; dat5(:,:,i)=wts;
    end
    mean(dat3')
    dat(:,ii)=myplot(wts,inps,ii);
    dat2(:,:,ii)=wts;
end

function out=myplot(wts,inps,ii)
out=netw(wts,[(-2:.01:2)',ones(401,1)]);
plot(-2:.01:2,out,'b',inps(:,1),netw(wts,inps),'r*'); axis([-2,2,-3,3]); 
reg=sum((wts(:,3).^2+(-wts(:,1)*2+wts(:,2)).^2).*((-wts(:,1)*2+wts(:,2))>0))+sum((wts(:,3).^2+(wts(:,1)*2+wts(:,2)).^2).*((wts(:,1)*2+wts(:,2))>0));
s=['implicit regularizer: ' num2str(reg)]; if nargin==3, s=['iteration: ' num2str(ii) ', ' s]; end
title(s); 
drawnow;

function [out,update]=netw(wts,inps,targ)
L1=max(inps*wts(:,1:2)',0);
out=L1*wts(:,3);
if nargout==2,%compute layer2 derivative (L2d), then layer1 derivative, then function error, then update
    L2d=ones(size(out));
    der2=bsxfun(@times,L2d,L1);
    L1d=(L1>0).*(L2d*wts(:,3)');
    err=out-targ;
    update=-[(L1d'*diag(err)*inps) (err'*der2)'];
end

